#ifndef __FIELD_GROUP__
#define __FIELD_GROUP__

namespace XMLIOSERVER
{   
   class FieldGroup : public GroupTemplate<CField, FieldAttribut>
   {
      public:
      
         FieldGroup(void) : GroupTemplate<CField, FieldAttribut>()
         {/* Ne rien faire de plus */}               
         FieldGroup(const string& _id) : GroupTemplate<CField, FieldAttribut>(_id)
         {/* Ne rien faire de plus */}
                         
         const char* getName(void) const {return ("Field_Group"); }  
         
         
         /// TODO A remonter dans l'arbre des héritages
         friend ostream& operator<< (ostream& out, const FieldGroup& c) 
         {   
            const AttributRegistrar &ar = c;
            out << IncIndent << "<" << c.getName() << c.printId() << ar << ">" << std::endl;            
            
            // Ecriture des sous-groupes.
            for(unsigned int i = 0; i < c.groupList.getVector().size() ; i++)
               out << *((FieldGroup*)c.groupList.getVector()[i])  << std::endl;
               
            // Ecriture des enfants.
            for(unsigned int i = 0; i < c.childList.getVector().size() ; i++)
               out << *(c.childList.getVector()[i]) << std::endl;
               
            out << NIndent << "</" << c.getName()<< ">" << DecEndl;
            
            return (out);
         }   
         
         /// TODO A remonter dans l'arbre des héritages   
         void resolveDescInheritance(const AttributRegistrar* _parent = 0)
         {
            const vector<CField*>&  childvect = childList.getVector();
            const vector<GroupTemplate<CField, FieldAttribut>*>& groupvect = groupList.getVector();
            
            // On complète les propres attributs du groupe.
            if (_parent!= NULL) addAttributes(*_parent);
            
            for(unsigned int i = 0; i < childvect.size() ; i++)
            // on complète les attributs des champs enfants
               childvect[i] -> addAttributes(*this);
               
            for(unsigned int i = 0; i < groupvect.size() ; i++)
            // on complète les attributs des groupes de champs enfants
               ((FieldGroup*)groupvect[i]) -> resolveDescInheritance(this);
         }
         
         void parse (XMLNode& _node, bool _withAttr = true)
         {
            string name = _node.getElementName();            
            THashAttributes attributes;

            /// PARSING GESTION DES ATTRIBUTS ///
            if (_withAttr)
            {
               _node.getAttributes(attributes);  
               this->setAttributes(attributes);
               
               if (attributes.end() != attributes.find("src"))
               { // Si une demande d'inclusion de fichier est trouvé.
                  XMLNode _node_inc = getNodeIncludedFile(attributes["src"], name);
                  parse (_node_inc);
               }
               
               attributes.clear();
            }
               
            /// PARSING POUR GESION DES ENFANTS
            if (!(_node.goToChildElement()))
               WARNING("Le groupe de champ ne contient pas d'enfant !");
            else
            {
               //////////////////////////////////////
               do { // Parcours des contexts pour traitement. 
                            
                  string name = _node.getElementName();
                  attributes.clear();
                  _node.getAttributes(attributes);  
                                 
                  if (name.compare("field_group") == 0)
                  { // Parsing pour les groupes de champs
                  
                     FieldGroup* fgroup = NULL;
                        
                     if (attributes.end() != attributes.find("id"))
                     {// Si l'identifiant est défini.
                        if (FieldGroup::HasObject(attributes["id"]))
                           WARNING("Dans le context actuel, un groupe de champ du même nom existe déjà, le second fera référence au premier par défaut !"); // TODO TODO
                        fgroup = (FieldGroup*)(&createGroup(attributes["id"]));
                        fgroup->parse(_node);
                     }
                     else
                     {// Si l'identifiant n'est pas défini.
                        fgroup = (FieldGroup*)(&createGroup());
                        fgroup->parse(_node);
                     }                        
                     continue;
                        
                  }
                  else if (name.compare("field") == 0)
                  { // Parsing pour les champs.
                  
                     CField* field = NULL;
                  
                     if (attributes.end() != attributes.find("id"))
                     {// Si l'identifiant est défini.
                        if (CField::HasObject(attributes["id"]))
                           WARNING("Dans le context actuel, un champ du même nom existe déjà, le second fera référence au premier par défaut !");  // TODO TODO
                        field = (CField*)(&createChild(attributes["id"]));
                        field->parse(_node);
                     }
                     else
                     {// Si l'identifiant n'est pas défini.
                        field = (CField*)(&createChild());
                        field->parse(_node);
                     }                  
                     continue;
                  } 
                  else
                     WARNING("Un groupe de champs ne peut contenir qu'un champ ou un autre groupe de champs !");
                     
               } while (_node.goToNextElement());
               //////////////////////////////////////
               _node.goToParentElement(); // Retour au parent  
            }
                                       
            return;
         }
         
         virtual ~FieldGroup(void) 
         {/* Ne rien faire de plus */ }
                 
   }; // class FieldGroup
     
   typedef FieldGroup FieldDefinition ;
   
}; // namespace XMLIOSERVER
   
#endif // __FIELD_GROUP__

