#ifndef __CFILE__
#define __CFILE__

using XMLIOSERVER::XML::XMLNode;
using XMLIOSERVER::XML::THashAttributes;

namespace XMLIOSERVER
{ 
   class CFile : public ObjectTemplate<CFile>, public FileAttribut
   {
      public:
      
         CFile(void) : ObjectTemplate<CFile>(), FileAttribut(), vfieldGroup(NULL)
			{/* Ne rien faire de plus */}	         	
			CFile(const string& _id) : ObjectTemplate<CFile>(_id), FileAttribut(), vfieldGroup(NULL)
         {/* Ne rien faire de plus */}	
         
         friend ostream& operator<< (ostream& out, const CFile& c) 
         {
            
            const AttributRegistrar &ar = c;
            out << IncIndent << "<" << c.getName() << c.printId() << ar << ">" << std::endl;           
            if(c.vfieldGroup != NULL) out << *c.vfieldGroup << std::endl;               
            out << NIndent << "</" << c.getName()<< ">" << DecEndl;
            
            return (out);
         }
                  
         const char* getName(void) const {return ("File"); }   

			void parse (XMLNode& _node)
			{
            string name = _node.getElementName();            
            THashAttributes attributes;
            
            /// PARSING GESTION DES ATTRIBUTS ///
            _node.getAttributes(attributes);  
            this->setAttributes(attributes);
            attributes.clear();
                       
            /// PARSING POUR GESION DES ENFANTS
            if (_node.goToChildElement() and hasId())
            { // Si la définition du fichier intégre des champs et si le fichier est identifié.
            
               _node.goToParentElement();
               
               vfieldGroup = (FieldGroup*)(&FieldGroup::CreateObject(getId()));
               vfieldGroup->parse(_node, false);
               
            } else _node.goToParentElement();
            
            return;
         }
         
         FieldGroup* getVirtualFieldGroup(void) { return (vfieldGroup); }
         bool  hasVirtualFieldGroup(void) { return (vfieldGroup != NULL); }
         
         ~CFile(void) 
         { if(vfieldGroup != NULL) delete vfieldGroup; } 
         
      private :
      
         FieldGroup* vfieldGroup; // FieldGroup "virtuel"
      
   }; // class CFile 
      
}; // namespace XMLIOSERVER
   
#endif // __CFILE__
